/* $Workfile: Demo2Io.h $   $Revision: 10 $    $Modtime: 1/28/08 5:01p $  */
#ifndef DEMO2_IO_H
#define DEMO2_IO_H
/*--------------------------------------------------------------------------*\

  Odin TeleSystems Inc.

  SAA-1007-1 OTX DSP C54x Software Development Kit (SDK)

  IOCLT Codes and Structs for communication between the DSP code and the
  DSPDMO2 user application

\*--------------------------------------------------------------------------*/


/*******************************************************************************
  @devnote
   DSP IOCTL codes.
*******************************************************************************/

#define DEMO2_IOCTL_SET_TX_GAIN            0x0100
#define DEMO2_IOCTL_GET_SAMPLE             0x0101
#define DEMO2_IOCTL_GET_DEBUG_DATA         0x0102
#define DEMO2_IOCTL_STREAM_RX_DATA         0x0103
#define DEMO2_IOCTL_SET_BLINK_FREQ         0x0104
#define DEMO2_IOCTL_GET_FULL_FRAME         0x0105
#define DEMO2_IOCTL_STREAM_FULL_FRAMES     0x0106
#define DEMO2_IOCTL_CONST_VAL_MODE_ENABLE  0x0107
#define DEMO2_IOCTL_CONST_VAL_MODE_DISABLE 0x0108
#define DEMO2_IOCTL_SET_CONST_VAL          0x0109
#define DEMO2_IOCTL_LOOP_ALL_TS            0x010A


/*******************************************************************************
  @devnote
   DSP Notify Event codes.
*******************************************************************************/

#define DEMO2_NOTIFY_DEBUG_DATA          0x0200
#define DEMO2_NOTIFY_STREAM_RX_DATA      0x0201
#define DEMO2_NOTIFY_STREAM_FULL_FRAMES  0x0202

/*******************************************************************************
  @devnote
   Structs for passing data over the DSP IOCTL interface
*******************************************************************************/


// Fix packing for IO Control Structs
#ifndef _TMS320C5XX
#pragma pack(2)
#endif

// Structs used in calls to OtxDspIoControl()
typedef struct Demo2IoInSetTxGainS
{
  short        nTxGain;
} Demo2IoInSetTxGainS;

typedef struct Demo2IoInStreamRxDataS
{
  short        bStreamRxData;
} Demo2IoInStreamRxDataS;

typedef struct Demo2IoInStreamFullFramesS
{
  short        bStreamFullFrames;
} Demo2IoInStreamFullFramesS;

typedef struct Demo2IoOutGetSampleS
{
  unsigned short        nResult;
  unsigned short        nDataSample;
} Demo2IoOutGetSampleS;

typedef struct Demo2IoOutGetFullFrameS
{
  unsigned short        nResult;
  unsigned short        nFrame[128];
} Demo2IoOutGetFullFrameS;

typedef struct Demo2IoInSetBlinkFreqS
{
  unsigned short        nBlinkCountFactor;
  unsigned short        nDummyData;
} Demo2IoInSetBlinkFreqS;

typedef struct Demo2IoInLoopAllTsS
{
  short        bLoopAllTs;
} Demo2IoInLoopAllTsS;

 

// Structs used for Notify Events
typedef struct Demo2NotifyGetDebugDataS
{
  unsigned short        nData0;
  unsigned short        nData1;
  unsigned short        nData2;
  unsigned short        nData3;
  unsigned short        nData4;
  unsigned short        nData5;
  unsigned short        nData6;
  unsigned short        nData7;

  unsigned short        sqBuf[32];
} Demo2NotifyGetDebugDataS;

typedef struct Demo2NotifyStreamRxDataS
{
  unsigned short        nData[25/* *16 */];
} Demo2NotifyStreamRxDataS;

typedef struct Demo2NotifyStreamFullFramesS
{
  unsigned short        nData[800/2]; // Must match OTXDSP_BSP_RXBUF_SIZE/2
} Demo2NotifyStreamFullFramesS;

typedef struct Demo2IoInSetConstValS
{
  unsigned short        bSet;       // 0 == turn off, otherwise set the constant value on
  unsigned short        nTimeSlot;  // timeslot to set/clear
  unsigned short        nConstVal;  // constant value to set
} Demo2IoInSetConstValS;


#ifndef _TMS320C5XX
#pragma pack()
#endif



#endif  // DEMO2_IO_H
